<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	JEVENTS
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppJevents extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_jevents.user';
	
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_jevents');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		$newStatus  = $new->getStatus();
		
		//get all params
		$published 			= $this->getAppParam('published');
		$cancreate			= $this->getAppParam('cancreate');
		$eventslimit		= $this->getAppParam('eventslimit'); 
		$canpublishown  	= $this->getAppParam('canpublishown');
		$candeleteown		= $this->getAppParam('candeleteown');
		$canedit			= $this->getAppParam('canedit');
		$canpublishall		= $this->getAppParam('canpublishall');
		$candeleteall		= $this->getAppParam('candeleteall');
		$canuploadimages	= $this->getAppParam('canuploadimages');
		$canuploadmovies	= $this->getAppParam('canuploadmovies');
		$cancreateown		= $this->getAppParam('cancreateown');
		$cancreateglobal	= $this->getAppParam('cancreateglobal');
		$extraslimit		= $this->getAppParam('extraslimit');
		$categories			= $this->getAppParam('categories');
				
		$subid  = $new->getId();
		$userid = $new->getBuyer();
		
		// if subscription is active
		if($newStatus == PayPlansStatus::SUBSCRIPTION_ACTIVE){										
			$this->_addToUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories, $subid);
			
			return true;
		}
		
		//if subscription is hold
		if($newStatus == PayPlansStatus::SUBSCRIPTION_HOLD){					
			$this->_resetUsers($userid, $subid);
			
			return true;
		}
		// if subscription is active
		if($newStatus == PayPlansStatus::SUBSCRIPTION_EXPIRED){						
			$this->_resetUsers($userid, $subid);
			
			return true;
		}
		
		return true;
	}
	
	protected function _addToUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories, $subid )
	{			
		//get all users from user table
		$users = $this->_getUsers();
		
		//when user alredy exists in Jevent user table, update data
		if(in_array($userid, $users)){
  	  
			//get current params of user
			$userParams = $this->_getUserParams($userid);
			
			$appParams = array('published' => $published, 'cancreate' => $cancreate,
						   'eventslimit' => $eventslimit, 'canpublishown' => $canpublishown,
						   'candeleteown' => $candeleteown, 'canedit' => $canedit,
						   'canpublishall' => $canpublishall, 'candeleteall' => $candeleteall,
						   'canuploadimages' => $canuploadimages, 'canuploadmovies' => $canuploadmovies,
						   'cancreateown' => $cancreateown, 'cancreateglobal' => $cancreateglobal,
						   'extraslimit' => $extraslimit, 'categories' => $categories);
			
			foreach(array_keys($appParams) as $param)
			{
				if($param == 'categories'){
					
					//allow all categories of active plans
					$previousCat = explode('|', $userParams->$param);
					$appParams[$param] = (is_array($appParams[$param])) ? $appParams[$param] : array($appParams[$param]);
					
					${$param}  = array_merge($appParams[$param], $previousCat);
					${$param}  = array_unique(${$param});
					continue;
				}
				
				if($param == 'eventslimit' || $param == 'extraslimit'){
					//allow total events
					${$param} = $appParams[$param] + $userParams->$param;
					continue;
				}
				//choose better value for user
				${$param} = ($appParams[$param] > $userParams->$param) ? $appParams[$param] : $userParams->$param;
				
			}
			
			//If there is more than 1 category
			if(is_array($categories)){
				$categories = implode('|', $categories);
			}
			 
			if($this->_updateUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories)){
				$this->_addToResource($subid, $userid, $categories, $this->_resource, $eventslimit);
			}
			return false;
		}
		
		//If there is more than 1 category
		if(is_array($categories)){
			$categories = implode('|', $categories);
		}
		
		//if its new user, create a new entry
		if($this->_insertUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories))
		{
			$this->_addToResource($subid, $userid, $categories, $this->_resource, $eventslimit);
		}
		
		return true;
	}
	
	protected function _resetUsers($userid, $subid)
	{
		//get all users from user table
		$allUsers = $this->_getUsers();
		
		//when user alredy exists in Jevent user table, update data
		if(in_array($userid, $allUsers)){
			
			//get all active plans of user
			$user 	   = PayplansUser::getInstance($userid);
			$userPlans = $user->getPlans();
			
			//initially assign default values
			$appParams   = array('published' => 0, 'cancreate' => 0, 'eventslimit' => 0,
						   'canpublishown' => 0, 'candeleteown' => 0, 'canedit' => 0,
						   'canpublishall' => 0, 'candeleteall' => 0, 'canuploadimages' => 0,
						   'canuploadmovies' => 0, 'cancreateown' => 0, 'cancreateglobal' => 0,
						   'extraslimit' => 0, 'categories' => null);
			
			$model = XiFactory::getInstance('app', 'model');
			$plansAppModel 	= XiFactory::getInstance('planapp', 'model');
			
			$jeventsApps	= $model->loadRecords(array('type' => 'jevents', 'published'=>1), array('limit'));
			
			foreach($jeventsApps as $app){
				//get app plans
				$coreParams = PayplansHelperParam::iniToArray($app->core_params);
				
				// is core app
				if(isset($coreParams['applyAll']) && intval($coreParams['applyAll']) === 1){
					$appPlans = PayplansHelperPlan::getPlans(array(), false);
				}
				else{
					// get plans from plan app
					$appPlans = $plansAppModel->getAppPlans($app->app_id);
				}
				
				$applicablePlans = array_intersect($appPlans, $userPlans);
				
				if(!empty($applicablePlans))
				{
					foreach($applicablePlans as $plan){
						
						$newParams  = PayplansHelperParam::iniToArray($app->app_params);
						
						foreach(array_keys($appParams) as $param)
						{
							if($param == 'categories'){
								
								//allow all categories of active plans
								$newParams[$param] = (is_array($newParams[$param])) ? $newParams[$param] : array($newParams[$param]);
								$appParams[$param] = (is_array($appParams[$param])) ? $appParams[$param] : array($appParams[$param]);
								
								$appParams[$param] = array_merge($appParams[$param], $newParams[$param]);
								$appParams[$param] = array_unique($appParams[$param]);
								$appParams[$param] = array_filter($appParams[$param]);
								continue;
							}
							
							if($param == 'eventslimit' || $param == 'extraslimit'){
								//allow total events
								$appParams[$param] = $appParams[$param] + $newParams[$param];
								continue;
							}
							//choose better value for user
							$appParams[$param] = ($appParams[$param] > $newParams[$param]) ? $appParams[$param] : $newParams[$param];
							
						}
					}
				}
				else{
					continue;
				}
			}
			
			//set final params in vaiables
			$published 			= $appParams['published'];
			$cancreate			= $appParams['cancreate'];
			$eventslimit		= $appParams['eventslimit']; 
			$canpublishown  	= $appParams['canpublishown'];
			$candeleteown		= $appParams['candeleteown'];
			$canedit			= $appParams['canedit'];
			$canpublishall		= $appParams['canpublishall'];
			$candeleteall		= $appParams['candeleteall'];
			$canuploadimages	= $appParams['canuploadimages'];
			$canuploadmovies	= $appParams['canuploadmovies'];
			$cancreateown		= $appParams['cancreateown'];
			$cancreateglobal	= $appParams['cancreateglobal'];
			$extraslimit		= $appParams['extraslimit'];
			$categories			= $appParams['categories'];
			
			//If there is more than 1 category
			if(is_array($categories)){
				$categories = implode('|', $categories);
			}
			 
			if($this->_updateUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories)){
				$this->_addToResource($subid, $userid, $categories, $this->_resource, $eventslimit);
			}
			return false;
		}
		return false;
	}
	
	protected function _getUsers()
	{
		$db = XiFactory::getDBO();

		$query = 'SELECT `user_id`'
			. ' FROM #__jev_users';
		$db->setQuery( $query );
		$users = $db->loadColumn();
		return $users;
	}
	
	protected function _insertUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories)
	{	
				
		$db = XiFactory::getDBO();
		
		$now = new XiDate();
		$created = $now-> toMySQL();
		
		$query = 'INSERT INTO `#__jev_users`'
			. ' (`user_id`, `published`, `cancreate`, `eventslimit`, `canpublishown`, `candeleteown`, 
				`canedit`, `canpublishall`, `candeleteall`, `canuploadimages`, `canuploadmovies`,
				`cancreateown`, `cancreateglobal`, `extraslimit`, `categories`, `created`)'
				
			. ' VALUES ( "'.$userid.'", "'.$published.'", "'.$cancreate.'", "'.$eventslimit.'", "'.$canpublishown.'",
			"'.$candeleteown.'", "'.$canedit.'", "'.$canpublishall.'", "'.$candeleteall.'", "'.$canuploadimages.'", "'.$canuploadmovies.'",
			"'.$cancreateown.'", "'.$cancreateglobal.'","'.$extraslimit.'","'.$categories.'", "'.$created.'")';

		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _updateUsers($userid, $published, $cancreate, $eventslimit, $canpublishown, $candeleteown, $canedit, $canpublishall,
				$candeleteall, $canuploadimages, $canuploadmovies, $cancreateown, $cancreateglobal, $extraslimit, $categories)
	{	
				
		$db = XiFactory::getDBO();
		
		$query = 'UPDATE `#__jev_users` '
				. ' SET `published` = "'.$published.'", `cancreate` = "'.$cancreate.'", 
				`eventslimit` = "'.$eventslimit.'",`canpublishown` = "'.$canpublishown.'",
				`candeleteown` = "'.$candeleteown.'", `canedit` = "'.$canedit.'",
				`canpublishall` = "'.$canpublishall.'", `candeleteall` = "'.$candeleteall.'",
				`canuploadimages` = "'.$canuploadimages.'", `canuploadmovies` = "'.$canuploadmovies.'",
				`cancreateown` = "'.$cancreateown.'", `cancreateglobal` = "'.$cancreateglobal.'",
				`extraslimit` = "'.$extraslimit.'", `categories` = "'.$categories.'"'
				
				.' WHERE `user_id` = "' . $userid.'" ';
		
		$db->setQuery( $query );
		return $db->query();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's jevents categories
	    $jevents_cat = $this->_getUserJeventsCategory($userid);
	    if(empty($jevents_cat)){
	    	return '';
	    }
	    $this->assign('jevents_cat',$jevents_cat);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	//get jdownloads user group
	protected function _getUserJeventsCategory($userid)
	{
		$jevents_cat	  = array();
		
		$db         	  = XiFactory::getDBO();
		$query      	  = 'SELECT `categories`'
			          		.' FROM #__jev_users'
			          		.' WHERE `user_id` = "'.$userid.'"';
		$db->setQuery( $query );	
        $catid  = $db->loadResult();
        $catid	= explode('|', $catid);
        
        foreach($catid as $id)
        {
        	$newquery      	  = 'SELECT `title`'
			          			.' FROM #__categories'
			          			.' WHERE `id` = "'.$id.'"';
			$db->setQuery( $newquery );	
	        $jevents_cat[]  = $db->loadResult();
        }
        return $jevents_cat;
	}
	
	protected function _getUserParams($userid)
	{
		$db = XiFactory::getDBO();

		$query = ' SELECT * FROM `#__jev_users`'
				.' WHERE `user_id` = "'.$userid.'"';
		$db->setQuery( $query );
		$userParams = $db->loadObject();
		return $userParams;
	}
}
